using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using CanAerospaceCore;
using FTD2XX_NET;
using System.Threading;

namespace WindowsFormsApplication2.MP5
{
    public partial class MP5Form : Form
    {
        public MP5Form()
        {
            InitializeComponent();
        }

        private void MP5Form_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.MP5_FormLocation = Location;
            Properties.Settings.Default.Save();
            
        }

        private void MP5Form_Load(object sender, EventArgs e)
        {
            StartPosition = FormStartPosition.Manual;
            Location = Properties.Settings.Default.MP5_FormLocation;
        }

        private void MP5_refresh_Click(object sender, EventArgs e)
        {
            Form1 mainform = Application.OpenForms.OfType<Form1>().First();
            mainform.ActiveForm2 = null;
            this.Close();
        }

        private void MP5_button_click(object sender, EventArgs e)
        {
            if (Application.OpenForms.OfType<Form1>().Any())
            {
                Form1 mainform = Application.OpenForms.OfType<Form1>().First();
                if (mainform.ActiveForm2 != null)
                {
                    Button button = sender as Button;
                    uint weaponChannel = 100;
                    byte weaponNodeId = 132;
                    CanData dataToWrite = new CanData();
                    //Thread.Sleep(1000);
                    byte register = 10;
                    switch (button.Name)
                    {
                        case ("MP5_shot"):
                            dataToWrite.SetAsUchar((byte)(16));
                            break;
                        default:
                            return;
                        //break;
                    }
                    RegisterKey regKey = new RegisterKey(weaponNodeId, register);
                    mainform.canConnection.SendRegisterWriteRequest(weaponChannel, regKey, dataToWrite);
                }

            }

        }

        public void MP5_numericUpDown_ValueChanged(object sender, EventArgs e)
        {
            NumericUpDown editbox = sender as NumericUpDown;
            uint weaponChannel = 100;
            byte weaponNodeId = 132;
            CanData dataToWrite = new CanData();
            //Thread.Sleep(1000);

            byte register = 0;
            switch (editbox.Name)
            {
                case ("MP5_treshlow"):
                    register = 29;
                    dataToWrite.SetAsUchar((byte)(editbox.Value));
                    break;
                case ("MP5_treshhigh"):
                    register = 30;
                    dataToWrite.SetAsUchar((byte)(editbox.Value));
                    break;
                case ("MP5_sensormin"):
                    register = 33;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("MP5_sensormax"):
                    register = 34;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("MP5_hallmax"):
                    register = 35;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("MP5_halfrange"):
                    register = 36;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("MP5_peakfilter"):
                    register = 37;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                default:
                    return;
                //break;
            }
            if (register == 0) return;
            if (Application.OpenForms.OfType<Form1>().Any())
            {
                Form1 mainform = Application.OpenForms.OfType<Form1>().First();
                if (mainform.ActiveForm2 != null)
                {
                    RegisterKey regKey = new RegisterKey(weaponNodeId, register);
                    if (mainform.canConnection.SendRegisterWriteRequest(weaponChannel, regKey, dataToWrite)) MessageBox.Show("Value changed");
                }

            }

        }

    }
}
